// RELOJ DE TIEMPO REAL 
// SUBRUTINA DE INTERRUPCION EN ANSI C
// PARA EVOLUPIC Bootloader 16F88
// maneja: segundos, minutos, horas, das, meses, aos.
// funciona solamente del ao 2001 al 2099
// considera tambin aos bisiestos.
// basado en cdigo fuente de Neutone. 
// y optimizaciones de C.Kielstra.
// PROGRAMA MUESTRA EN LCD LA HORA
// CON HORA INICIAL 00:00:00 

#include "16F88adc.h" 
#include "keyadc.h"
#include <stdio.h>
#use delay(clock=4000000) 

//RTC variables 
#define CRISTAL  4000000 
#define FRECUENCIA_TIMER1 (CRISTAL / 4)  // 1 tick = frecuencia del cristal/4 
int32 Ticker; 
int8 Segundos=0;  
int8 Year=0,Mes=0,Dia=0,Hora=0,Minuto=0; 
#define BISIESTO(year) (year%4 == 0)

void LCD_CEROS(void)
{char CEROS[10]="00:00:00";		//HORA INICIAL
 initLCD();
 clearLCD();
 PutLCD("HORA:");
 cursorXY(1,0);
 stringLCD(CEROS);
} 

void DISPLAY_LCD(void)
{char wob[10];
 cursorXY(1,0);
 sprintf(wob,"%02u",Hora);
 stringLCD(wob); 
 cursorXY(1,3);
 sprintf(wob,"%02u",Minuto);
 stringLCD(wob); 
 cursorXY(1,6);
 sprintf(wob,"%02u",Segundos);
 stringLCD(wob); 
}

//Inicializa TIMER1  

void Inicializa_RTC(void) 
{ 
  Ticker = FRECUENCIA_TIMER1;                 // 1 Tick = 1 us. 
  setup_timer_1( T1_INTERNAL | T1_DIV_BY_1 ); // initializa TIMER1 para interrupcin 
                                              // cada 65536 us.                                              
  enable_interrupts( INT_TIMER1 );            // habilita interrupcin TIMER1 
} 

//AQUI INICIA LA SUBRUTINA DE INTERRUPCION DEL TIMER 1  
//EL ALGORITMO ES EXACTO.

#int_TIMER1                                
void TIMER1_isr()                          //subrutina de interrupcin.
{ 
  Ticker -= 65536;                        // Decrementa ticker 
  if ( Ticker < 65536 )                   // Si ya pas 1 segundo 
  {  Ticker += FRECUENCIA_TIMER1;          //   Incrementa ticker 
     Segundos++;                           //   Incrementa segundos 
  } 
  
  if(Segundos == 60) {Minuto++; Segundos=0; 
    if(Minuto == 60) {Hora++; Minuto=0; 
      if(Hora == 24) {Dia++; Hora=0; 
        if (  (Dia == 29 && Mes==2 && !BISIESTO(Year)) 
           || (Dia == 30 && Mes==2) 
           || (Dia == 31 && (Mes==4 || Mes==6 || Mes==9 || Mes==11 )) 
           || (Dia == 32) 
           ) {Mes++;Dia=0;} 
        	if(Mes == 13) {Year++; Mes=0;} 
  }}}   
} 

// PROGRAMA PRINCIPAL MUESTRA LA HORA EN EL LCD 

#rom 0X0000={0X018A,0X28FF}	//DATOS REQUERIDOS POR TINY					
#build(reset=0x00FF)

void main() 
{ 
  int8 segundo_previo;   
  Inicializa_RTC(); 
  enable_interrupts(GLOBAL); 
  TRISA=0;
  RA0=0;
  TRISB=0;
  PORTB=0;
  LCD_CEROS();
  while(1) 
  { if (Segundos != segundo_previo) 
    {segundo_previo=Segundos; 
      DISPLAY_LCD();
    }  
  } 
} 

